﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.Odbc;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace bug78367
{
  public partial class Form1 : Form
  {

    int conn_id = 0;

    public Form1()
    {
      InitializeComponent();
    }

    private void read_result(OdbcDataReader rd)
    {
      while (rd.Read())
      {
        conn_id = rd.GetInt32(1);
        textBox2.AppendText("CONNECTION_ID: " + conn_id.ToString() + Environment.NewLine);
        textBox2.AppendText("SERVER REPLY: " + rd[0].ToString() + Environment.NewLine);
      }
    }

    private void button1_Click(object sender, EventArgs e)
    {
      textBox2.AppendText("Opening a new connection...." + Environment.NewLine);
      OdbcConnection conn = new OdbcConnection(textBox1.Text);
      
      OdbcConnection conn2 = new OdbcConnection(textBox1.Text); // this connection will be using to kill conn
      try
      {
        conn.Open();
        conn2.Open();
      }
      catch(Exception ex)
      {
        textBox2.AppendText("Error!" + Environment.NewLine + ex.Message + Environment.NewLine + "Try again later!" + Environment.NewLine);
        return;
      }

      textBox2.AppendText("[CONNECTION OPENED]" + Environment.NewLine);

      string cmd_text = "SELECT 'OK From MySQL Server', connection_id()";

      OdbcCommand cmd = new OdbcCommand(cmd_text, conn);

      try
      {
        textBox2.AppendText("Executing SQL: " + cmd_text + Environment.NewLine);
        OdbcDataReader rd = cmd.ExecuteReader();
        read_result(rd);
        rd.Close();
      }
      catch (Exception ex)
      {
        textBox2.AppendText("Error!" + Environment.NewLine + ex.Message + Environment.NewLine + "Try again later!" + Environment.NewLine);
        return;
      }

      textBox2.AppendText("Kill the connection ID=" + conn_id + Environment.NewLine);

      OdbcCommand cmd2 = new OdbcCommand("kill " + conn_id, conn2);
      try
      {
        cmd2.ExecuteNonQuery();
      }
      catch (Exception ex)
      {
        textBox2.AppendText("Error!" + Environment.NewLine + ex.Message + Environment.NewLine + "Try again later!" + Environment.NewLine);
        return;
      }

      textBox2.AppendText("[CONNECTION ID=" + conn_id + " IS KILLED]" + Environment.NewLine);

      try
      {
        textBox2.AppendText("Executing SQL: " + cmd_text + Environment.NewLine);
        OdbcDataReader rd = cmd.ExecuteReader();
        read_result(rd);
        rd.Close();
      }
      catch (Exception ex)
      {
        textBox2.AppendText("EXPECTED ERROR!" + Environment.NewLine + ex.Message + Environment.NewLine + "RETRYING COMMAND!" + Environment.NewLine);
        try
        {
          textBox2.AppendText("Executing SQL: " + cmd_text + Environment.NewLine);
          OdbcDataReader rd = cmd.ExecuteReader();
          read_result(rd);
          rd.Close();
        }
        catch (Exception ex2)
        {
          textBox2.AppendText("Something went wrong!" + Environment.NewLine + ex2.Message + Environment.NewLine);
        }

      }

      textBox2.AppendText("[TEST SUCCESS]" + Environment.NewLine);
      conn.Close();
      conn2.Close();
    }

    private void button2_Click(object sender, EventArgs e)
    {
      textBox2.Clear();
    }
  }
}
